<template>
  <div class="form-group dropdown">
    <input
        ref="userInput"
        type="text"
        :placeholder="props.placeholder"
        :value="data.userInput"
        autocomplete="off"
        class="form-control form-control-sm user-input"
        id="elem"
        tabindex="0"
        :disabled="props.disabled"
        :required="props.required"
        @input="userInputChange"
        @blur="outsideClick()"
        @focus="cleanUserInput()"
        @click="cleanUserInput()"
        @keyup.enter="selectAutocompleteElemEnter()"
        @keyup.down="changeOptionSelected(1)"
        @keyup.up="changeOptionSelected(-1)"
    />
    <div
      class="dropdown-menu"
      :class="{ show: data.dropdownElements.length > 0 }"
      data-popper-placement="top-start"
    >
      <a
          class="dropdown-item"
          :class="{selected: data.itemIndexSelected == index}"
          v-for="(elem, index) in data.dropdownElements"
          :key="elem.key"
          v-text="elem.value"
          @mousedown="selectAutocompleteElem(elem)"
      ></a>
    </div>
  </div>
</template>

<script setup lang="ts">
import { reactive, watch, type PropType } from "vue";
import type AutocompleteElement from './AutocompleteElement';

const props = withDefaults(defineProps<{
  modelValue: AutocompleteElement | null,
  elements: AutocompleteElement[],
  initKey: number | string | null,
  placeholder: string,
  minLength: number,
  disabled: boolean,
  required?: boolean // Opcional
}>(),{
  modelValue: null,
  placeholder: "Ingrese para comenzar a buscar...",
  initKey: null,
  minLength: 2,
  disabled: false,
  required: false
});


const emit = defineEmits<{
  (e: "update:model-value", elem: AutocompleteElement | null): void
}>();

const data = reactive({
  userInput: "" as string,
  dropdownElements: [] as AutocompleteElement[],
  itemIndexSelected: 0 as number
});

function selectAutocompleteElem(elem: AutocompleteElement){
  emit('update:model-value', elem);
  data.dropdownElements = [];
}
function selectAutocompleteElemEnter(){
  selectAutocompleteElem(data.dropdownElements[data.itemIndexSelected]);  
}
function cleanUserInput(){
  data.itemIndexSelected = 0;
  data.userInput = "";
  data.dropdownElements = [];
  emit('update:model-value', null);
}
function outsideClick(){
  if(props.modelValue == null){
    cleanUserInput();
  }
}
function findElementsByValue(value: string): AutocompleteElement[]{
  return props.elements.filter((elem: AutocompleteElement)=>{
    return elem.value.toLowerCase().includes(value.toLowerCase());
  });
}
function findElementByKey(key: number | string): AutocompleteElement | null {
  let element: AutocompleteElement | undefined = props.elements.find((elem: AutocompleteElement) => {
    if (typeof elem.key === "string") {
      return elem.key === key;    
    } else if (typeof elem.key === "number") {
      return elem.key === Number(key);    
    }
  });
  return (element !== undefined)? element : null;
}
function userInputChange(event: Event){
  data.userInput = (event.target as HTMLInputElement).value;

  //  VALIDACIÓNES variable USER INPUT
  if(data.userInput.length < props.minLength){ // La longitud es menor que el mínimo requerido
    data.itemIndexSelected = 0;
    data.dropdownElements = [];
    emit('update:model-value', null);
    return;
  }
  
  // BUSQUEDA DE ELEMENTOS
  data.dropdownElements = findElementsByValue(data.userInput);
  
  // VALIDACIÓNES BUSQUEDA
  if(data.dropdownElements.length == 0){ // No se encontraron elementos
 
    return;
  }
  
}
function changeOptionSelected(position: number):void {
  let result: number = data.itemIndexSelected + position;
  if(result < 0){
    result = 0;
  }
  if(result >= data.dropdownElements.length){
    result = data.dropdownElements.length - 1;
  }
  data.itemIndexSelected = result;
}

watch((() => props.initKey), (newValue: number | string | null, oldValue: number | string | null)=>{
  if(newValue != null){
    let element: AutocompleteElement | null = findElementByKey(newValue);
    emit('update:model-value', element);
  }
});
 
watch((() => props.modelValue), (newValue: AutocompleteElement | null, oldValue: AutocompleteElement | null)=>{
  if(newValue != null){
    data.userInput = newValue.value;
  } else {
    data.userInput = "";
  }
});

</script>

<style scoped>

.dropdown-menu {
  border-top-right-radius: 0px !important;
  border-top-left-radius: 0px !important;
  width: auto !important;
  position: absolute !important;
}

.selected {
  /* background-color: #e9ecef; */
  background-color: #e9ecef !important;
}

.user-input {
  border-bottom-left-radius: 0px !important;
  border-bottom-right-radius: 0px !important;
}

input:focus{
    outline: none;
}
</style>